{{- if and .Values.autoscaling.enabled .Values.autoscaling.keda.enabled }}
{{- range $_, $instance := .Values.instances }}
---
apiVersion: keda.sh/v1alpha1
kind: ScaledObject
metadata:
  name: {{ include "pubsubbeat.fullname" $ }}-{{ $instance.topic }}
  labels:
    {{- include "pubsubbeat.labels" $ | nindent 4 }}
spec:
  scaleTargetRef:
    apiVersion: apps/v1
    kind: Deployment
    name: {{ include "pubsubbeat.fullname" $ }}-{{ $instance.topic }}
  minReplicaCount: {{ ($instance.autoscaling | default dict).minReplicas | default $.Values.autoscaling.minReplicas }}
  maxReplicaCount: {{ ($instance.autoscaling | default dict).maxReplicas | default $.Values.autoscaling.maxReplicas }}
  advanced:
    horizontalPodAutoscalerConfig:
      behavior:
        scaleDown:
          {{- toYaml $.Values.autoscaling.scaleDown | nindent 10 }}
        scaleUp:
          {{- toYaml $.Values.autoscaling.scaleUp | nindent 10 }}
  triggers:
    {{- if or ($instance.autoscaling | default dict).targetCPUUtilizationPercentage $.Values.autoscaling.targetCPUUtilizationPercentage }}
    - type: cpu
      metricType: Utilization
      metadata:
        value: {{ ($instance.autoscaling | default dict).targetCPUUtilizationPercentage | default $.Values.autoscaling.targetCPUUtilizationPercentage | quote }}
    {{- end }}
    {{- if or ($instance.autoscaling | default dict).targetMemoryUtilizationPercentage $.Values.autoscaling.targetMemoryUtilizationPercentage }}
    - type: memory
      metricType: Utilization
      metadata:
        value: {{ ($instance.autoscaling | default dict).targetMemoryUtilizationPercentage | default $.Values.autoscaling.targetMemoryUtilizationPercentage | quote }}
    {{- end }}
    {{- if eq ($instance.google_project | default $.Values.google_project) $.Values.google_project }}
      {{- if or ($instance.autoscaling | default dict).targetPubSubUndeliveredMessages $.Values.autoscaling.targetPubSubUndeliveredMessages }}
    {{- /* See https://keda.sh/docs/2.9/scalers/gcp-pub-sub/ */ -}}
    - type: gcp-pubsub
      metricType: Value
      authenticationRef:
        name: {{ include "pubsubbeat.kedaTriggerAuthGCPName" $ }}
      metadata:
        mode: SubscriptionSize
        value: {{ ($instance.autoscaling | default dict).targetPubSubUndeliveredMessages | default $.Values.autoscaling.targetPubSubUndeliveredMessages | quote }}
        subscriptionName: {{ $instance.subscription | default (printf "%s-sub" $instance.topic) | quote }}
      {{- end }}
      {{- if or ($instance.autoscaling | default dict).targetPubSubOldestUnackedMessageAge $.Values.autoscaling.targetPubSubOldestUnackedMessageAge }}
    - type: gcp-pubsub
      metricType: Value
      authenticationRef:
        name: {{ include "pubsubbeat.kedaTriggerAuthGCPName" $ }}
      metadata:
        mode: OldestUnackedMessageAge
        value: {{ ($instance.autoscaling | default dict).targetPubSubOldestUnackedMessageAge | default $.Values.autoscaling.targetPubSubOldestUnackedMessageAge | quote }}
        subscriptionName: {{ $instance.subscription | default (printf "%s-sub" $instance.topic) | quote }}
      {{- end }}
    {{- end }}
{{- end }}
{{- end }}
